// 005 u_c_enchanted_maze_factory_1
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_enchanted_maze_factory_1;
  interface
    uses u_c_maze_1, u_c_enchanted_room_and_door_1
        , u_c_maze_factory_1;

    type c_enchanted_maze_factory= class(c_maze_factory)
                                     Constructor create_enchanted_maze_factory;

                                     function _f_c_cast_spell: c_spell;
                                     function f_c_create_room(p_room_number: Integer): c_room; Override;
                                     function f_c_create_door(p_c_from_room, p_c_to_room: c_room): c_door; Override;
                                   end; // c_enchanted_maze_factory

  implementation

    // -- c_enchanted_maze_factory

    Constructor c_enchanted_maze_factory.create_enchanted_maze_factory;
      begin
        Inherited create_maze_factory;
      end; // create_enchanted_maze_factory

    function c_enchanted_maze_factory._f_c_cast_spell: c_spell;
      begin
        Result:= c_spell.create_spell;
      end; // _f_c_cast_spell

    function c_enchanted_maze_factory.f_c_create_room(p_room_number: Integer): c_room;
      begin
        Result:= c_enchanted_room.create_enchanted_room(p_room_number, _f_c_cast_spell);
      end; // f_c_create_room

    function c_enchanted_maze_factory.f_c_create_door(p_c_from_room, p_c_to_room: c_room): c_door;
      begin
        Result:= c_door.create_door(p_c_from_room, p_c_to_room);
      end; // f_c_create_door

    begin // u_c_maze_factory
    end. // u_c_maze_factory


