// 005 u_c_maze_factory_1
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_maze_factory_1;
  interface
    uses u_c_maze_1;

    type c_maze_factory= class
                           Constructor create_maze_factory;

                           function f_c_create_maze: c_maze; Virtual;
                           function f_c_create_wall: c_wall; Virtual;
                           function f_c_create_room(p_room_number: Integer): c_room; Virtual;
                           function f_c_create_door(p_c_from_room, p_c_to_room: c_room): c_door; Virtual;
                         end; // c_maze_factory

  implementation

    // -- c_maze_factory

    Constructor c_maze_factory.create_maze_factory;
      begin
        Inherited Create;
      end; // create_maze_factory

    function c_maze_factory.f_c_create_maze: c_maze;
      begin
        Result:= c_maze.create_maze;
      end; // f_c_create_maze

    function c_maze_factory.f_c_create_wall: c_wall;
      begin
        Result:= c_wall.create_wall;
      end; // f_c_create_wall

    function c_maze_factory.f_c_create_room(p_room_number: Integer): c_room;
      begin
        Result:= c_room.create_room(p_room_number);
      end; // f_c_create_room

    function c_maze_factory.f_c_create_door(p_c_from_room, p_c_to_room: c_room): c_door;
      begin
        Result:= c_door.create_door(p_c_from_room, p_c_to_room);
      end; // f_c_create_door

    begin // u_c_maze_factory
    end. // u_c_maze_factory

