// 005 u_c_maze_game_1_2
// 11 dec 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   Felix John COLIBRI  http://www.felix-colibri.com

(*$r+*)

unit u_c_maze_game_1_2;
  interface
    uses u_c_maze_1, u_c_maze_factory_1;

    type c_maze_game_2= Class
                        constructor create_maze_game_2;
                        function f_c_create_maze_2(p_c_maze_factory: c_maze_factory): c_maze;
                      end; // c_maze_game_2

  implementation

    // -- c_maze_game_2

    constructor c_maze_game_2.create_maze_game_2;
      begin
        Inherited;
      end; // create_maze_game_2

    function c_maze_game_2.f_c_create_maze_2(p_c_maze_factory: c_maze_factory): c_maze;
      var l_c_room_1: c_room;
          l_c_room_2: c_room;
          l_c_door: c_door;
      begin
        with p_c_maze_factory do
        begin
          Result:= f_c_create_maze;
          l_c_room_1:= f_c_create_room(1);
          l_c_room_2:= f_c_create_room(2);
          l_c_door:= f_c_create_door(l_c_room_1, l_c_room_2);

          Result.add_room(l_c_room_1);
          Result.add_room(l_c_room_2);

          with l_c_room_1 do
          begin
            set_side(e_north, c_wall.create_wall);
            set_side(e_east, l_c_door);
            set_side(e_south, c_wall.create_wall);
            set_side(e_west, c_wall.create_wall);
          end;

          with l_c_room_2 do
          begin
            set_side(e_north, c_wall.create_wall);
            set_side(e_east, c_wall.create_wall);
            set_side(e_south, c_wall.create_wall);
            set_side(e_west, l_c_door);
          end;
        end; // with p_c_maze_factory
      end; // f_c_create_maze

    begin // u_c_yyy
    end. // u_c_yyy
